
#property copyright "Copyright  2006, Hendrick."
#include <stdlib.mqh>
#include <stderror.mqh>

int MAGICMA_A=10;
int MAGICMA_B=20;
int MAGICMA01=30;
int MAGICMA02=40;
int MAGICMA03=50;

// 
//
//
//
//

extern string     GeneralSettings         = "===== General Settings ============================";
extern int        PhoenixMode             = 3;
extern double     Lots                    = 1;
extern double     PctToRisk               = 5;
extern bool       DecreaseAfterlost       = false;
extern bool       MM                      = true;
extern bool       Log                     = false;
extern bool       ShowComment             = false;
extern bool       PrefSettings            = true;
extern int        ServerTimezone          = 0;
extern int        CloseAfterHours         = 0;

extern string     StopLossTrailing        = "====== For PhoenixMode 1  &&  PhoenixMode 2 ======";
extern int        TrailingStep            = 1;

extern string     Mode1                   = "====== Phoenix Mode 1 (Classic) ==================";
extern int        M1_TakeProfit           = 0;
extern int        M1_StopLoss             = 0;
extern int        M1_BreakEven            = 0;
extern int        M1_TrailingStop         = 0;  

extern string     Mode2                   = "====== Phoenix Mode 2 (Second trade)==============";
extern int        M2_OpenTrade_2          = 0;
extern int        M2_TakeProfit           = 0;
extern int        M2_StopLoss             = 0;
extern int        M2_BreakEven            = 0;
extern int        M2_TrailingStop         = 0;  
extern bool       M2_CloseFirstTrade      = false;
extern int        M2_CloseFirstAfterPips  = 0;
     
extern string     Mode3                   = "====== Phoenix Mode 3 (Three trades at once) =====";
extern int        M3_CloseTrade2_3        = 0;
extern int        M3_TakeProfit           = 0;
extern int        M3_StopLoss             = 0;

extern string     Signal1                 = "====== Signal 1 ===================================";
extern bool       UseSignal1              = true;
extern double     Percent                 = 0;
extern int        EnvelopePeriod          = 0;

extern string     Signal2                 = "====== Signal 2 ==================================";
extern bool       UseSignal2              = true;
extern int        SMAPeriod               = 0;
extern int        SMA2Bars                = 0;

extern string     Signal3                 = "====== Signal 3 ==================================";
extern bool       UseSignal3              = true;
extern int        OSMAFast                = 0;
extern int        OSMASlow                = 0;
extern double     OSMASignal              = 0;

extern string     Signal4                 = "====== Signal 4 ==================================";
extern bool       UseSignal4              = true;
extern int        Fast_Period             = 0;
extern int        Fast_Price              = 1;   //PRICE_OPEN;
extern int        Slow_Period             = 0;
extern int        Slow_Price              = 1;   //PRICE_OPEN;
extern double     DVBuySell               = 0;
extern double     DVStayOut               = 0;

extern string     Signal5                 = "====== Signal 5 =================================";
extern bool       UseSignal5              = true;
extern int        TradeFrom1              = 0;
extern int        TradeUntil1             = 24;
extern int        TradeFrom2              = 0;
extern int        TradeUntil2             = 0;
extern int        TradeFrom3              = 0;
extern int        TradeUntil3             = 0;
extern int        TradeFrom4              = 0;
extern int        TradeUntil4             = 0;

//
//
//
//
//

double pointvalue;
double MinLots = 0;
double MaxLots = 0;
double LotStep = 0;
double MaxPctToRisk = 20;
double FakeProfit;
double dLots;
double StopTradeB=0.0;
double SL_A=0.0;
double TP_A=0.0;
int    aantal=2;
int    Start;
int    count;
int    iError,Slippage;
int    NumberOfTries  = 5; //Number of tries to set, close orders;
int    RetryTime   = 1;
int    lasttrade = 0;
string filename="";
string TradeLog;

//
//
//
//
//

int init()
{
        if (Digits == 4 || Digits == 2) { pointvalue = Point;       Slippage = 3;  }
   else if (Digits == 5 || Digits == 3) { pointvalue = 10.0 * Point;Slippage = 30; }

//+------------------------------------------------------------------+
//| START Preffered Settings                                         |
//+------------------------------------------------------------------+
//
//

if (PrefSettings == true)
{
   if (StringFind(Symbol(), "USDJPY", 0)>=0) 
   {
     M1_TakeProfit    = 42;            //PhoenixMode1
     M1_StopLoss      = 30;
     M1_BreakEven     = 0;  
     M1_TrailingStop  = 0;          
                  
     M2_OpenTrade_2   = 0;             //PhoenixMode2
     M2_TakeProfit    = 50;
     M2_StopLoss      = 30;
     M2_BreakEven     = 0;  
     M2_TrailingStop  = 0;              

     M3_CloseTrade2_3 = 30;            //PhoenixMode3
     M3_TakeProfit    = 100;
     M3_StopLoss      = 30;

     Percent          = 0.0032;        //Signal 1
     EnvelopePeriod   = 2;
      
     SMAPeriod        = 15;            //Signal 2
     SMA2Bars         = 5;
                                          
     OSMAFast         = 5;             //Signal 3
     OSMASlow         = 22;
     OSMASignal       = 2;
      
     Fast_Period      = 25;             //Signal 4
     Slow_Period      = 15;
     DVBuySell        = 0.00029;
     DVStayOut        = 0.024;
    
   }
                
   if (StringFind(Symbol(), "GBPUSD", 0)>=0)
   {      
     M1_TakeProfit    = 42;            //PhoenixMode1
     M1_StopLoss      = 30;
     M1_BreakEven     = 0;  
     M1_TrailingStop  = 0;          
                  
     M2_OpenTrade_2   = 5;             //PhoenixMode2
     M2_TakeProfit    = 95;
     M2_StopLoss      = 30;
     M2_BreakEven     = 0;  
     M2_TrailingStop  = 0;              

     M3_CloseTrade2_3 = 90;            //PhoenixMode3
     M3_TakeProfit    = 110;
     M3_StopLoss      = 30;

     Percent          = 0.0023;        //Signal 1
     EnvelopePeriod   = 6;
      
     SMAPeriod        = 3;            //Signal 2
     SMA2Bars         = 14;
                                          
     OSMAFast         = 23;             //Signal 3
     OSMASlow         = 17;
     OSMASignal       = 15;
      
     Fast_Period      = 25;             //Signal 4
     Slow_Period      = 37;
     DVBuySell        = 0.00042;
     DVStayOut        = 0.05;

   }
                
   if (StringFind(Symbol(), "EURUSD", 0)>=0)
   {
     M1_TakeProfit    = 42;            //PhoenixMode1
     M1_StopLoss      = 30;
     M1_BreakEven     = 0;  
     M1_TrailingStop  = 0;          
                  
     M2_OpenTrade_2   = 10;             //PhoenixMode2
     M2_TakeProfit    = 90;
     M2_StopLoss      = 30;
     M2_BreakEven     = 0;  
     M2_TrailingStop  = 0;              

     M3_CloseTrade2_3 = 85;            //PhoenixMode3
     M3_TakeProfit    = 130;
     M3_StopLoss      = 30;

     Percent          = 0.0056;        //Signal 1
     EnvelopePeriod   = 10;
      
     SMAPeriod        = 5;            //Signal 2
     SMA2Bars         = 9;
                                          
     OSMAFast         = 5;             //Signal 3
     OSMASlow         = 12;
     OSMASignal       = 11;
      
     Fast_Period      = 9;             //Signal 4
     Slow_Period      = 29;
     DVBuySell        = 0.00034;
     DVStayOut        = 0.004;
     
   }
   
   if (StringFind(Symbol(), "USDCHF", 0)>=0)
   {            
     M1_TakeProfit    = 42;            //PhoenixMode1
     M1_StopLoss      = 30;
     M1_BreakEven     = 0;  
     M1_TrailingStop  = 0;          
                  
     M2_OpenTrade_2   = 10;             //PhoenixMode2
     M2_TakeProfit    = 90;
     M2_StopLoss      = 30;
     M2_BreakEven     = 0;  
     M2_TrailingStop  = 0;              

     M3_CloseTrade2_3 = 85;            //PhoenixMode3
     M3_TakeProfit    = 130;
     M3_StopLoss      = 30;

     Percent          = 0.0056;        //Signal 1
     EnvelopePeriod   = 10;
      
     SMAPeriod        = 5;              //Signal 2
     SMA2Bars         = 5;
                                          
     OSMAFast         = 5;             //Signal 3
     OSMASlow         = 12;
     OSMASignal       = 11;
      
     Fast_Period      = 5;             //Signal 4
     Slow_Period      = 20;
     DVBuySell        = 0.00022;
     DVStayOut        = 0.0015;
    
   }
   
   if (StringFind(Symbol(), "AUDUSD", 0)>=0)
   {            
     M1_TakeProfit    = 42;            //PhoenixMode1
     M1_StopLoss      = 30;
     M1_BreakEven     = 0;  
     M1_TrailingStop  = 0;          
                  
     M2_OpenTrade_2   = 10;             //PhoenixMode2
     M2_TakeProfit    = 90;
     M2_StopLoss      = 30;
     M2_BreakEven     = 0;  
     M2_TrailingStop  = 0;              

     M3_CloseTrade2_3 = 85;            //PhoenixMode3
     M3_TakeProfit    = 130;
     M3_StopLoss      = 30;

     Percent          = 0.0056;        //Signal 1
     EnvelopePeriod   = 10;
      
     SMAPeriod        = 5;            //Signal 2
     SMA2Bars         = 9;
                                          
     OSMAFast         = 5;             //Signal 3
     OSMASlow         = 12;
     OSMASignal       = 11;
      
     Fast_Period      = 9;             //Signal 4
     Slow_Period      = 20;
     DVBuySell        = 0.00022;
     DVStayOut        = 0.0015;    

   }
   
   if (StringFind(Symbol(), "GBPJPY", 0)>=0)
   {            
     M1_TakeProfit    = 62;            //PhoenixMode1
     M1_StopLoss      = 30;
     M1_BreakEven     = 0;  
     M1_TrailingStop  = 0;          
                  
     M2_OpenTrade_2   = 0;             //PhoenixMode2
     M2_TakeProfit    = 130;
     M2_StopLoss      = 30;
     M2_BreakEven     = 0;  
     M2_TrailingStop  = 0;              

     M3_CloseTrade2_3 = 40;            //PhoenixMode3
     M3_TakeProfit    = 90;
     M3_StopLoss      = 30;

     Percent          = 0.0072;        //Signal 1
     EnvelopePeriod   = 2;
      
     SMAPeriod        = 8;            //Signal 2
     SMA2Bars         = 12;
                                          
     OSMAFast         = 5;             //Signal 3
     OSMASlow         = 36;
     OSMASignal       = 10;
      
     Fast_Period      = 17;             //Signal 4
     Slow_Period      = 28;
     DVBuySell        = 0.0034;
     DVStayOut        = 0.063;    
     
   }
   
   if (StringFind(Symbol(), "EURJPY", 0)>=0)
   {            
     M1_TakeProfit    = 60;            //PhoenixMode1
     M1_StopLoss      = 30;
     M1_BreakEven     = 0;  
     M1_TrailingStop  = 0;          
                  
     M2_OpenTrade_2   = 18;             //PhoenixMode2
     M2_TakeProfit    = 70;
     M2_StopLoss      = 30;
     M2_BreakEven     = 0;  
     M2_TrailingStop  = 0;              

     M3_CloseTrade2_3 = 55;            //PhoenixMode3
     M3_TakeProfit    = 70;
     M3_StopLoss      = 30;

     Percent          = 0.007;        //Signal 1
     EnvelopePeriod   = 2;
      
     SMAPeriod        = 4;            //Signal 2
     SMA2Bars         = 16;
                                          
     OSMAFast         = 11;             //Signal 3
     OSMASlow         = 20;
     OSMASignal       = 14;
      
     Fast_Period      = 20;             //Signal 4
     Slow_Period      = 10;
     DVBuySell        = 0.0078;
     DVStayOut        = 0.026;   
     
   }
}
return(0);
}

//+------------------------------------------------------------------+
//| END Preffered Settings                                           |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| START EA                                                         |
//| MrPip moved code from CheckOpenTrade to speed backtest           |
//+------------------------------------------------------------------+

void start()
{
    int Signal=0;
    
    filename=Symbol() + TradeLog + "-" + Month() + "-" + Day() + ".log";
      
    if(Bars<100) { Print("bars less than 100"); return(0);  }

    if(errorchek()!=""){Alert(errorchek());Sleep(4000);return(0);}

    if (ShowComment) subPrintDetails(); // Added ShowComment check to speed backtest by MrPip


    if(PhoenixMode==1)//Phoenix Classic
    {
       if(CalculateCurrentOrders() < 1)
       {
         StopTradeB=0;
         SL_A=0;
         TP_A=0;
         aantal=0;  
         if (NewBar() == false) return(0); // Added by MrPip - Only need signal at close of bar
         Signal = CheckSignal();           // Added by MrPip - Only need to call once
         if (Signal == 0) return(0);       // Added by MrPip to speed backtesting
         CheckOpenTrade(Signal);
       }
       else
       {
        HandleCurrentOrders();  // MrPip - Copied code from CalculateCurrentOrders to new function     
        if(CloseAfterHours != 0)  CheckCloseAfterHours();
        if(M1_BreakEven != 0)     CheckBreakEven();
        if(M1_TrailingStop != 0)  CheckTrailingStop();
       }
   }
              
   if(PhoenixMode==2)//Phoenix Second Trade
   {
       if(CalculateCurrentOrders() < 1)
       {
         StopTradeB=0;
         SL_A=0;
         TP_A=0;
         aantal=0;  
         if (NewBar() == false) return(0); // Added by MrPip - Only need signal at close of bar 
         Signal = CheckSignal();           // Added by MrPip - Only need to call once
         if (Signal == 0) return(0);       // Added by MrPip to speed backtesting
         CheckOpenTrade(Signal);
        }
        else
        {    
          HandleCurrentOrders();     
          if(CloseAfterHours != 0)  CheckCloseAfterHours();
          CheckSecondTrade();
          if(M2_BreakEven != 0)     CheckBreakEven();
          if(M2_TrailingStop != 0)  CheckTrailingStop();
        }
   }

   if(PhoenixMode==3)//Phoenix 123
   {
       if (Mode3_CalculateCurrentOrders() < 1)
       {
         if (NewBar() == false) return(0); // Added by MrPip - Only need signal at close of bar 
         Signal = CheckSignal();
         if (Signal == 0) return(0);
         CheckOpenTradeMode123(Signal);     //checking and opening new orders
       }
       else
       {
         Mode3_HandleCurrentOrders();
         Mode3_MoveSL_Trade_2_3();           
         Mode3_MoveSL_Trade_3();
         if(M3_CloseTrade2_3 != 0) CheckCloseTrade23();
       }
      
   }
} 
     
//+------------------------------------------------------------------+
//| END EA                                                           |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Calculate open positions                          |
//+------------------------------------------------------------------+
int CalculateCurrentOrders()
  {
   int count=0;
    int total = OrdersTotal();

   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()!=Symbol()) continue;
      if (OrderMagicNumber()==MAGICMA_A || OrderMagicNumber()==MAGICMA_B)
        {
         count++;
         if(count>aantal){aantal=count;}
        }
     }
     return(count);
  }

//+------------------------------------------------------------------+
//| STOP Function Calculate open positions                           |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Handle open positions                             |
//| MrPip moved code from CalculateCurrentOrders for faster backtest |
//+------------------------------------------------------------------+
void HandleCurrentOrders()
  {
    int total = OrdersTotal();
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()!=Symbol()) continue;
      if (OrderMagicNumber()==MAGICMA_A || OrderMagicNumber()==MAGICMA_B)
        {
         if(OrderStopLoss()==0 && OrderTakeProfit()==0)
            {
             if(OrderMagicNumber()==MAGICMA_A)
              {
                TradeLog = "FirstTrade";
                if (OrderType()==OP_BUY)
                 {
                  if((PhoenixMode==1)&&(M1_TakeProfit>0 || M1_StopLoss>0))
                    {
                     SL_A=(OrderOpenPrice()-M1_StopLoss*pointvalue);
                     TP_A=(OrderOpenPrice()+M1_TakeProfit*pointvalue);
                    }
                  if((PhoenixMode==2)&&(M2_TakeProfit>0 || M2_StopLoss>0))
                    {
                     SL_A=(OrderOpenPrice()-M2_StopLoss*pointvalue);
                     TP_A=(OrderOpenPrice()+M2_TakeProfit*pointvalue);
                    }
                 }                                         
                if (OrderType()==OP_SELL)
                 {
                  if((PhoenixMode==1)&&(M1_TakeProfit>0 || M1_StopLoss>0))                
                    {
                     SL_A=(OrderOpenPrice()+M1_StopLoss*pointvalue);
                     TP_A=(OrderOpenPrice()-M1_TakeProfit*pointvalue);
                    }
                  if((PhoenixMode==2)&&(M2_TakeProfit>0 || M2_StopLoss>0))
                    {
                     SL_A=(OrderOpenPrice()+M2_StopLoss*pointvalue);
                     TP_A=(OrderOpenPrice()-M2_TakeProfit*pointvalue);
                    }
                 }                                         
                ModifyOrder(SL_A,TP_A);
               }
             if((OrderMagicNumber()==MAGICMA_B)&&(M2_TakeProfit>0 || M2_BreakEven>0))
              {
               if (TP_A>0 || SL_A>0)
               {               
                TradeLog = "Mode2_SecondTrade";
                ModifyOrder(SL_A,TP_A);
               }                           
              }
            }         

         if(OrderMagicNumber()==MAGICMA_B)
           {
            if (OrderType()==OP_BUY)
              {
               if (OrderStopLoss()>=OrderOpenPrice()){StopTradeB=OrderStopLoss();}
              }
            if (OrderType()==OP_SELL)
              {
               if (OrderStopLoss()<=OrderOpenPrice()){StopTradeB=OrderStopLoss();}
              }
           }
         if(OrderMagicNumber()==MAGICMA_A )
           {
            if (OrderType()==OP_BUY)
              {
               if(Bid>(OrderOpenPrice()+(M2_CloseFirstAfterPips*pointvalue))&& M2_CloseFirstTrade && (aantal==2))
                 {
                  OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet); 
                  return(count);
                 }
               if(StopTradeB>OrderStopLoss() && OrderStopLoss()>0) // && StopTradeB<OrderOpenPrice())
                 {
                  TradeLog = "FirstTrade";
                  ModifyOrder(StopTradeB,FakeProfit);   //OrderOpenPrice()+M1_TakeProfit*pointvalue);
                 }
              }                               
            if (OrderType()==OP_SELL)
              {
               if((OrderStopLoss()>0.01 && Ask<(OrderOpenPrice()-(M2_CloseFirstAfterPips*pointvalue))) && M2_CloseFirstTrade && (aantal==2))
                 {
                  OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet); 
                  return(count);
                 }                           
               if(StopTradeB<OrderStopLoss() && StopTradeB>OrderOpenPrice())
                 {
                  TradeLog = "FirstTrade";
                  ModifyOrder(StopTradeB,FakeProfit);   //OrderOpenPrice()-M1_TakeProfit*pointvalue);
                 }
              }                 
           }
        }
     }
}

//+------------------------------------------------------------------+
//| STOP Function Handle open positions                              |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Check Open Trade                                  |
//+------------------------------------------------------------------+
int CheckOpenTrade(int signal)
{      
int err = 0;

   if(signal==1)
      {
      if(OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,Slippage,0,0,"FirstTrade",MAGICMA_A,0,Coral) < 0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
       return(0);
      }
      
   if(signal==2)
      {
      if(OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,Slippage,0,0,"FirstTrade",MAGICMA_A,0,LightBlue) < 0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
      return(0);
      }
}
//+------------------------------------------------------------------+
//| END Function Check Open Trade                                    |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Calculate Current Orders Mode 3                   |
//+------------------------------------------------------------------+
int Mode3_CalculateCurrentOrders()
  {
   int buys=0,sells=0;

   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()!=Symbol()) continue; 
      if(Mode3_CheckMagic(OrderMagicNumber()))
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;                   
        }
     }
    return(buys+sells);
  }
//+------------------------------------------------------------------+
//| STOP Function Calculate Current Orders Mode 3                    |
//+------------------------------------------------------------------+

bool Mode3_CheckMagic(int Magic)
{
  if (Magic==MAGICMA01) return(true);
  if (Magic==MAGICMA02) return(true); 
  if (Magic==MAGICMA03)  return(true);
  return(false);
}

//+------------------------------------------------------------------+
//| START Function Handle Current Orders Mode 3                   |
//+------------------------------------------------------------------+
int Mode3_HandleCurrentOrders()
{

   for(int i=0;i<OrdersTotal();i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if (OrderSymbol()!=Symbol()) continue; 
      if(Mode3_CheckMagic(OrderMagicNumber()))
      {
         if(OrderStopLoss()==0 && OrderTakeProfit()==0)
         {
             if (M3_TakeProfit>0 || M3_StopLoss>0)
             {
               if(OrderMagicNumber()==MAGICMA01)
               {
                TradeLog = "Mode3_FirstTrade";
                if (OrderType()==OP_BUY){ModifyOrder(OrderOpenPrice()-M3_StopLoss*pointvalue,OrderOpenPrice()+NormalizeDouble(M3_TakeProfit/2,0)*pointvalue);}
                if (OrderType()==OP_SELL){ModifyOrder(OrderOpenPrice()+M3_StopLoss*pointvalue,OrderOpenPrice()-NormalizeDouble(M3_TakeProfit/2,0)*pointvalue);}
               }  
               if(OrderMagicNumber()==MAGICMA02)
               {               
                TradeLog = "Mode3_SecondTrade";
                if (OrderType()==OP_BUY){ModifyOrder(OrderOpenPrice()-M3_StopLoss*pointvalue,OrderOpenPrice()+M3_TakeProfit*pointvalue);}
                if (OrderType()==OP_SELL){ModifyOrder(OrderOpenPrice()+M3_StopLoss*pointvalue,OrderOpenPrice()-M3_TakeProfit*pointvalue);}
               }                           
               if(OrderMagicNumber()==MAGICMA03)
               {               
                TradeLog = "Mode3_ThirdTrade";
                if (OrderType()==OP_BUY){ModifyOrder(OrderOpenPrice()-M3_StopLoss*pointvalue,OrderOpenPrice()+NormalizeDouble(M3_TakeProfit*1.5,0)*pointvalue);}
                if (OrderType()==OP_SELL){ModifyOrder(OrderOpenPrice()+M3_StopLoss*pointvalue,OrderOpenPrice()-NormalizeDouble(M3_TakeProfit*1.5,0)*pointvalue);}
               }                           
             }
         }                  
      }
   }
}
//+------------------------------------------------------------------+
//| STOP Function Handle Current Orders Mode 3                    |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START MODE 3 Function Check Open Trade                           |
//+------------------------------------------------------------------+
int CheckOpenTradeMode123(int signal)
{
     
   int err = 0;

   int decimalPlaces=1;
   double LotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
   double minLot  = MarketInfo(Symbol(), MODE_MINLOT );  
   if(LotStep<0.1) decimalPlaces=2;
   double lots123 = NormalizeDouble(LotsOptimized()/3,decimalPlaces);

   if(lots123 < minLot){lots123=minLot;}

   
   if(signal==1)
      {
      if(OrderSend(Symbol(),OP_SELL,lots123,Bid,Slippage,0,0,"Mode3_FirstTrade",MAGICMA01,0,Red)<0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
           
      if(OrderSend(Symbol(),OP_SELL,lots123,Bid,Slippage,0,0,"Mode3_SecondTrade",MAGICMA02,0,Red)<0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
      
      if(OrderSend(Symbol(),OP_SELL,lots123,Bid,Slippage,0,0,"Mode3_ThirdTrade",MAGICMA03,0,Red)<0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
      return(0);
      }
      
   if(signal==2)
      {
      if(OrderSend(Symbol(),OP_BUY,lots123,Ask,Slippage,0,0,"Mode3_FirstTrade",MAGICMA01,0,Blue)<0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }      
      if(OrderSend(Symbol(),OP_BUY,lots123,Ask,Slippage,0,0,"Mode3_SecondTrade",MAGICMA02,0,Blue)<0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
      if(OrderSend(Symbol(),OP_BUY,lots123,Ask,Slippage,0,0,"Mode3_ThirdTrade",MAGICMA03,0,Blue)<0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
      return(0);
      }
}

//+------------------------------------------------------------------+
//| END Function Check Open Trade                                    |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Check Second Trade                                |
//+------------------------------------------------------------------+

void CheckSecondTrade()
{
int err = 0, total = OrdersTotal();

for(int z = total - 1; z >= 0; z --)
   {
   if(!OrderSelect( z, SELECT_BY_POS))
      {
      err = GetLastError();
      Print("OrderSelect( ", z, ", SELECT_BY_POS ) - Error #",err );
      continue;
      }

   if(OrderSymbol() != Symbol()) continue;

   if(OrderMagicNumber() == MAGICMA_B) break;
 
   if(OrderMagicNumber() != MAGICMA_A) continue;
   
    if(aantal<2)
      {
      if(OrderType() == OP_BUY && M2_OpenTrade_2 >= 0 && (Bid-OrderOpenPrice() > pointvalue*M2_OpenTrade_2))
        {   
         if(OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,Slippage,0,0,"Mode2_SecondTrade",MAGICMA_B,0,Blue) < 0)
           {
            err = GetLastError();
            Print("Error Ordersend(",err,"): ");
            return(-1);
           }
         return(0);  
        }

      if(OrderType() == OP_SELL && M2_OpenTrade_2 >= 0 && (OrderOpenPrice()-Ask > pointvalue*M2_OpenTrade_2))
        {
         if(OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,Slippage,0,0,"Mode2_SecondTrade",MAGICMA_B,0,Red) < 0)
           {
            err = GetLastError();
            Print("Error Ordersend(",err,"): ");
            return(-1);
           } 
         return(0);
        }

      if(OrderType() == OP_BUY && M2_OpenTrade_2 < 0 && (Bid-OrderOpenPrice() < pointvalue*M2_OpenTrade_2))
        {   
         if(OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,Slippage,0,0,"Mode2_SecondTrade",MAGICMA_B,0,Blue) < 0)
           {
            err = GetLastError();
            Print("Error Ordersend(",err,"): ");
            return(-1);
           }
         return(0);  
        }

      if(OrderType() == OP_SELL && M2_OpenTrade_2 < 0 && (OrderOpenPrice()-Ask < pointvalue*M2_OpenTrade_2))
        {
         if(OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,Slippage,0,0,"Mode2_SecondTrade",MAGICMA_B,0,Red) < 0)
           {
            err = GetLastError();
            Print("Error Ordersend(",err,"): ");
            return(-1);
           }
         return(0);
        }      
     }            
   }
}

//+------------------------------------------------------------------+
//| END Function Check Second Trade                                  |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Check Close Trade 2 And 3                         |
//+------------------------------------------------------------------+
void CheckCloseTrade23()
{

int err = 0, total = OrdersTotal();
bool CloseTrade=false;

for(int z = total - 1; z >= 0; z --)
   {
   if(!OrderSelect( z, SELECT_BY_POS))
      {
      err = GetLastError();
      Print("OrderSelect( ", z, ", SELECT_BY_POS ) - Error #",err );
      continue;
      }

   if(OrderSymbol() != Symbol()) continue;

   if(OrderMagicNumber() != MAGICMA01) continue;
   
      if((OrderType() == OP_BUY && OrderStopLoss() < OrderOpenPrice())||(OrderType() == OP_SELL && OrderStopLoss() > OrderOpenPrice())){
        if(OrderMagicNumber()==MAGICMA02)
          {               
           TradeLog = "Mode3_SecondTrade";
           if ((OrderType()==OP_BUY)&&(Bid-OrderOpenPrice()) > (pointvalue*M1_BreakEven))
                {ModifyOrder(OrderOpenPrice(),OrderOpenPrice()+M3_TakeProfit*pointvalue);}
           if ((OrderType()==OP_SELL)&&(OrderOpenPrice()-Ask) > (pointvalue*M1_BreakEven))
                {ModifyOrder(OrderOpenPrice(),OrderOpenPrice()-M3_TakeProfit*pointvalue);}
          }                           
        if(OrderMagicNumber()==MAGICMA03)
          {               
           TradeLog = "Mode3_ThirdTrade";
           if ((OrderType()==OP_BUY)&&(Bid-OrderOpenPrice()) > (pointvalue*M1_BreakEven))
                {ModifyOrder(OrderOpenPrice(),OrderOpenPrice()+NormalizeDouble(M3_TakeProfit*1.5,0)*pointvalue);}
           if ((OrderType()==OP_SELL)&&(OrderOpenPrice()-Ask) > (pointvalue*M1_BreakEven))
                {ModifyOrder(OrderOpenPrice(),OrderOpenPrice()-NormalizeDouble(M3_TakeProfit*1.5,0)*pointvalue);}
          }                                 
        }    
   
   if(OrderType() == OP_BUY && (OrderOpenPrice()-Bid > pointvalue * M3_CloseTrade2_3)) {CloseTrade=true;}
   if(OrderType() == OP_SELL && (Ask-OrderOpenPrice() > pointvalue * M3_CloseTrade2_3)) {CloseTrade=true;}

   if(CloseTrade)
      {
      for(int y = total - 1; y >= 0; y --)
         {
         if(!OrderSelect( y, SELECT_BY_POS))
            {
            err = GetLastError();
            Print("OrderSelect( ", y, ", SELECT_BY_POS ) - Error #",err );
            continue;
            }
         if(OrderSymbol() != Symbol()) continue;

         if(OrderMagicNumber() == MAGICMA02 || OrderMagicNumber() == MAGICMA03)
            {
            if(OrderType() == OP_BUY)
               {
               if(OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet)<0)
                  {
                  err = GetLastError();
                  Print("Error Ordersend(",err,"): ");
                  return(-1);
                  }
               return(0); 
               }
            if(OrderType() == OP_SELL)
               {
               if(OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet)<0)
                  {      
                  err = GetLastError();
                  Print("Error Ordersend(",err,"): ");
                  return(-1);
                  }
              return(0); 
               }
             }
}
}
}
}


//+------------------------------------------------------------------+
//| END Function Check Close Trade 2 And 3                           |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Check First Trade Mode3                                    |
//+------------------------------------------------------------------+



void Mode3_MoveSL_Trade_2_3()
{
int err = 0, total = OrdersTotal(), history = HistoryTotal();
bool ChangeStopLoss = false;

for(int z = history - 1; z >= 0; z --)
   {
   if(!OrderSelect( z,SELECT_BY_POS,MODE_HISTORY))
      {
      err = GetLastError();
      Print("OrderSelect( ", z, ", SELECT_BY_POS ) - Error #",err );
      continue;
      }

   if(OrderSymbol() != Symbol()) continue;

   if(OrderMagicNumber() == MAGICMA03) break;
   
   if(OrderMagicNumber() == MAGICMA02) break;
 
   if(OrderMagicNumber() != MAGICMA01) continue;

   if(OrderProfit() > 0) 
      {
      ChangeStopLoss=true;
      break;
      }
   }


  if(ChangeStopLoss==true)
   {
   for(int y = total - 1; y >= 0; y --)
      {
      if(!OrderSelect(y,SELECT_BY_POS))
         {
         err = GetLastError();
         Print("OrderSelect( ", y, ", SELECT_BY_POS ) - Error #",err );
         continue;
         }

      if(OrderSymbol() != Symbol()) continue;
      if((OrderType() == OP_BUY && ((OrderStopLoss()+1*pointvalue) < OrderOpenPrice()))||(OrderType() == OP_SELL && ((OrderStopLoss()-1*pointvalue) > OrderOpenPrice()))||OrderStopLoss()==0)
       {
        if(OrderMagicNumber()==MAGICMA02)
          {               
           TradeLog = "Mode3_SecondTrade";
           if ((OrderType()==OP_BUY)&&(Bid-OrderOpenPrice()) > (pointvalue*M1_BreakEven))
                {ModifyOrder(OrderOpenPrice(),OrderOpenPrice()+M3_TakeProfit*pointvalue);}
           if ((OrderType()==OP_SELL)&&(OrderOpenPrice()-Ask) > (pointvalue*M1_BreakEven))
                {ModifyOrder(OrderOpenPrice(),OrderOpenPrice()-M3_TakeProfit*pointvalue);}
          }                           
        if(OrderMagicNumber()==MAGICMA03)
          {               
           TradeLog = "Mode3_ThirdTrade";
           if ((OrderType()==OP_BUY)&&(Bid-OrderOpenPrice()) > (pointvalue*M1_BreakEven))
                {ModifyOrder(OrderOpenPrice(),OrderOpenPrice()+NormalizeDouble(M3_TakeProfit*1.5,0)*pointvalue);}
           if ((OrderType()==OP_SELL)&&(OrderOpenPrice()-Ask) > (pointvalue*M1_BreakEven))
                {ModifyOrder(OrderOpenPrice(),OrderOpenPrice()-NormalizeDouble(M3_TakeProfit*1.5,0)*pointvalue);}
          }                                 
        }          
}
}
}
//+------------------------------------------------------------------+
//| END Check First Trade Mode 3                                     |
//+------------------------------------------------------------------+

 
//+------------------------------------------------------------------+
//| START Check Second Trade Mode3                                   |
//+------------------------------------------------------------------+

void Mode3_MoveSL_Trade_3()
{
 int err = 0, total = OrdersTotal(), history = HistoryTotal();
 bool ChangeStopLoss = false;

for(int z = history - 1; z >= 0; z --)
   {
   if(!OrderSelect( z,SELECT_BY_POS,MODE_HISTORY))
      {
      err = GetLastError();
      Print("OrderSelect( ", z, ", SELECT_BY_POS ) - Error #",err );
      continue;
      }

   if(OrderSymbol() != Symbol()) continue;

   if(OrderMagicNumber() == MAGICMA03) break;
   
   if(OrderMagicNumber() == MAGICMA01) break;
 
   if(OrderMagicNumber() != MAGICMA02) continue;

   if(OrderProfit() > 0) 
      {
      for(int y = total - 1; y >= 0; y --)
         {
         if(!OrderSelect(y,SELECT_BY_POS))
            {
            err = GetLastError();
            Print("OrderSelect( ", y, ", SELECT_BY_POS ) - Error #",err );
            continue;
            }

         if(OrderSymbol() != Symbol()) continue;

        if(OrderMagicNumber()==MAGICMA03)
          {               
           TradeLog = "Mode3_ThirdTrade";
           if ((OrderType()==OP_BUY)&&(OrderStopLoss() - OrderOpenPrice()< 3 * pointvalue))
                {ModifyOrder(OrderOpenPrice()+(NormalizeDouble(M3_TakeProfit*0.75,0)*pointvalue),OrderOpenPrice()+NormalizeDouble(M3_TakeProfit*1.5,0)*pointvalue);}
           if ((OrderType()==OP_SELL)&&(OrderOpenPrice() - OrderStopLoss() < 3 * pointvalue))
                {ModifyOrder(OrderOpenPrice()-(NormalizeDouble(M3_TakeProfit*0.75,0)*pointvalue),OrderOpenPrice()-NormalizeDouble(M3_TakeProfit*1.5,0)*pointvalue);}
          }                                 
        }
     }
   }
}

//+------------------------------------------------------------------+
//| END Check Second Trade Mode 3                                    |
//+------------------------------------------------------------------+ 
 
  
//+------------------------------------------------------------------+
//| START Function Diverge                                           |
//+------------------------------------------------------------------+

double divergence(int F_Period, int S_Period, int F_Price, int S_Price, int mypos)
  {
    int i;
    double maF1, maF2, maS1, maS2;

    maF2 = iMA(Symbol(), 0, F_Period, 0, MODE_SMA, F_Price, mypos + 1);
    maS2 = iMA(Symbol(), 0, S_Period, 0, MODE_SMA, S_Price, mypos + 1);

    return(maF2-maS2);
  }

//+------------------------------------------------------------------+
//| END Function Diverge                                             |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Valid Trade Time                                  |
//+------------------------------------------------------------------+

bool F_ValidTradeTime (int iHour)
   {
      if(((iHour >= TradeFrom1) && (iHour <= (TradeUntil1-1)))||((iHour>= TradeFrom2) && (iHour <= (TradeUntil2-1)))||((iHour >= TradeFrom3)&& (iHour <= (TradeUntil3-1)))||((iHour >= TradeFrom4) && (iHour <=(TradeUntil4-1))))
      {
       return (true);
      }
      else
       return (false);
   }  

//+------------------------------------------------------------------+
//| END Function Valid Trade Time                                    |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Check Close Trade After x Hours                            |
//+------------------------------------------------------------------+

void CheckCloseAfterHours()
{
int total = OrdersTotal();

for(int cnt=0;cnt<total;cnt++)
   {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
   if( OrderSymbol()!=Symbol()) continue;
   if( OrderMagicNumber()==MAGICMA_A)
      {            
         if((CurTime()-OrderOpenTime())>(CloseAfterHours*3600))
           if(OrderType()==OP_BUY)
            {
            OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet);
            }
           if(OrderType()==OP_SELL)
            {
            OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet);
            }            
      }
   }
}

//+------------------------------------------------------------------+
//| END Check Close Trade After x Hours                              |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Check Signals                                     |
//+------------------------------------------------------------------+
// Modified by MrPip for faster backtesting

//=====================SIGNAL1========================
int CheckSignal()
{

bool BuySignal1=false, SellSignal1=false;


if(UseSignal1)
{
double HighEnvelope1 = iEnvelopes(NULL,0,EnvelopePeriod,MODE_SMA,0,PRICE_CLOSE,Percent,MODE_UPPER,1);
double LowEnvelope1  = iEnvelopes(NULL,0,EnvelopePeriod,MODE_SMA,0,PRICE_CLOSE,Percent,MODE_LOWER,1);
double CloseBar1     = iClose(NULL,0,1);
   if(CloseBar1 > HighEnvelope1) {SellSignal1 = true;} 
   if(CloseBar1 < LowEnvelope1)  {BuySignal1  = true;}
}
else {SellSignal1=true;BuySignal1=true;}



//=====================SIGNAL2========================

bool BuySignal2=false, SellSignal2=false;


if(UseSignal2)
{
double SMA1=iMA(NULL,0,SMAPeriod,0,MODE_SMA,PRICE_CLOSE,1);
double SMA2=iMA(NULL,0,SMAPeriod,0,MODE_SMA,PRICE_CLOSE,SMA2Bars);
   if(SMA2-SMA1>0) {BuySignal2  = true;}
   if(SMA2-SMA1<0) {SellSignal2 = true;}
}
else {SellSignal2=true;BuySignal2=true;}



//=====================SIGNAL3========================

bool BuySignal3=false, SellSignal3=false;


if(UseSignal3)
{
double OsMABar2=iOsMA(NULL,0,OSMAFast,OSMASlow,OSMASignal,PRICE_CLOSE,2);
double OsMABar1=iOsMA(NULL,0,OSMAFast,OSMASlow,OSMASignal,PRICE_CLOSE,1);
   if(OsMABar2 < OsMABar1)  {SellSignal3 = true;}
   if(OsMABar2 > OsMABar1)  {BuySignal3  = true;}
}
else {SellSignal3=true;BuySignal3=true;}


      
//=====================SIGNAL4========================  

   double diverge;
   bool BuySignal4=false,SellSignal4=false;
   

if(UseSignal4)
{
   diverge = divergence(Fast_Period, Slow_Period, Fast_Price, Slow_Price,0);
   if(diverge >= DVBuySell && diverge <= DVStayOut)
       {BuySignal4 = true;}
   if(diverge <= (DVBuySell*(-1)) && diverge >= (DVStayOut*(-1))) 
       {SellSignal4 = true;} 
}       
else {SellSignal4=true;BuySignal4=true;}


    
//=====================SIGNAL5=======================  

bool BuySignal5=false, SellSignal5=false;

if(UseSignal5)
{
   int iHour=TimeHour(TimeCurrent()+ ((  0 - ServerTimezone) * 3600));
   int ValidTradeTime = F_ValidTradeTime(iHour);
   if(ValidTradeTime==true)
    {
    BuySignal5=true;
    SellSignal5=true;
    }
}
else {SellSignal5=true;BuySignal5=true;}

if((SellSignal1==true) && (SellSignal2==true) && (SellSignal3==true) && (SellSignal4==true) && (SellSignal5==true)) return(1);  
if((BuySignal1==true) && (BuySignal2==true) && (BuySignal3==true) && (BuySignal4==true) && (BuySignal5==true)) return(2);
return (0);
}

//+------------------------------------------------------------------+
//| END Function Check Signals                                       |
//+------------------------------------------------------------------+   

//+------------------------------------------------------------------+
//| START Calculate optimal lot size                                 |
//+------------------------------------------------------------------+ 
double LotsOptimized() 
 {
  dLots=Lots;
   MinLots = MarketInfo(Symbol(), MODE_MINLOT);
   MaxLots = MarketInfo(Symbol(), MODE_MAXLOT);
   LotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
      //MM  Setup function to calculate Lots
      //    Tranform Lots to Integer Multiple of LotsStep, then set within Max/Min Limit
      //    This new MM will work with different MinLot and LotStep 
      //     such as Alpari UK Classic which have Minimum 0.1 then 0.11, 0.12, 0.13 etc
      double StopLossPoint;
      if (PhoenixMode == 1){StopLossPoint = M1_StopLoss;}
      if (PhoenixMode == 2){StopLossPoint = M2_StopLoss;}
      if (PhoenixMode == 3){StopLossPoint = M3_StopLoss;}

      double RiskEquity = AccountEquity() * (PctToRisk/100);
      double eRiskEquity = AccountEquity() * (MaxPctToRisk/100);
      double PipValue = MarketInfo(Symbol(), MODE_TICKVALUE) * (pointvalue / MarketInfo(Symbol(), MODE_TICKSIZE));
      double eLots = eRiskEquity / (StopLossPoint * PipValue);
  if(MM){dLots = RiskEquity / (StopLossPoint * PipValue);}
  if(eLots < dLots){dLots = eLots;}   
  if (dLots < MinLots){dLots = MinLots;}
  dLots = MinLots + NormalizeDouble(((dLots - MinLots) / LotStep),0) * LotStep;
  if (dLots > MaxLots){dLots = MaxLots;}               
  if(DecreaseAfterlost)
    {
     int losses =0;
     double ddLots = dLots;
     for (int ioht=OrdersHistoryTotal() -1; ioht >= 0; ioht--) 
       { 
        OrderSelect(ioht, SELECT_BY_POS, MODE_HISTORY);
        if (OrderMagicNumber() == MAGICMA_A && PhoenixMode == 1)
          {
           if (OrderProfit() < 0)
                       {
                        losses++;
                        if (losses == 1){dLots = 0.9*ddLots;}
                        if (losses >= 2)
                          {
                           dLots = 0.1*ddLots;
                           ioht = 0;
                          }
                       }
           if (OrderProfit() >= 0){ioht = 0;}
          }
        if (OrderMagicNumber() == MAGICMA_B && PhoenixMode == 2)
          {
           if (OrderProfit() < 0)
                       {
                        losses++;
                        if (losses == 1){dLots = 0.9*ddLots;}
                        if (losses >= 2)
                          {
                           dLots = 0.1*ddLots;
                           ioht =0;
                          }
                       }           
           if (OrderProfit() >= 0){ioht = 0;}           
          }
        if (OrderMagicNumber() == MAGICMA01 && PhoenixMode == 3)
          {
           if (OrderProfit() < 0)
                       {
                        losses++;
                        if (losses == 1){dLots = 0.9*ddLots;}
                        if (losses >= 2)
                          {
                           dLots = 0.1*ddLots;
                           ioht =0;
                          }
                       }           
           if (OrderProfit() >= 0){ioht = 0;}           
          }
       }     
    }
  dLots = MinLots + NormalizeDouble(((dLots - MinLots) / LotStep),0) * LotStep;  
  if (dLots < MinLots){dLots = MinLots;}                      
  return (dLots);
 } 
 
   
//+------------------------------------------------------------------+
//| END Calculate optimal lot size                                   |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Check TrailingStop                                |
//+------------------------------------------------------------------+
void CheckTrailingStop()
{
   for(int i=0;i<OrdersTotal();i++)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if( OrderSymbol()!=Symbol()) continue;
      if((OrderMagicNumber() != MAGICMA_A)&&(OrderMagicNumber() != MAGICMA_B)) continue;
     
      if(OrderType() == OP_BUY)
        {
         if(OrderMagicNumber()== MAGICMA_A)
           {
            TradeLog = "FirstTrade";
            if((PhoenixMode==1)&&(M1_TrailingStop>=1))
              {
               FakeProfit=(OrderOpenPrice()+(2*M1_TakeProfit*pointvalue));
               if(OrderStopLoss()<(OrderOpenPrice()+(M1_TakeProfit*pointvalue)))
                 {
                  if(((Bid - OrderStopLoss()) > (pointvalue * (M1_TrailingStop+TrailingStep))) && (OrderStopLoss() >= OrderOpenPrice() ))
                     ModifyOrder(Bid - pointvalue * M1_TrailingStop,FakeProfit);
                 }
               if(Bid>(OrderOpenPrice()+(M1_TakeProfit*pointvalue)))
                 {
                  OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet); 
                  return(0);
                 }
              }
            if((PhoenixMode==2)&&(M2_TrailingStop>=1))                                 
              {
               FakeProfit=(OrderOpenPrice()+(2*M2_TakeProfit*pointvalue));
               if(OrderStopLoss()<(OrderOpenPrice()+(M2_TakeProfit*pointvalue)))
                 {
                  if(((Bid - OrderStopLoss()) > (pointvalue * (M2_TrailingStop+TrailingStep))) && (OrderStopLoss() >= OrderOpenPrice() ))
                     ModifyOrder(Bid - pointvalue * M2_TrailingStop,FakeProfit);
                 }
               if(Bid>(OrderOpenPrice()+(M2_TakeProfit*pointvalue)))
                 {
                  OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet); 
                  return(0);
                 }
              }
           }   

         if((OrderMagicNumber()== MAGICMA_B)&&(M2_TrailingStop>=1))
           {
            TradeLog = "Mode2_SecondTrade";
            if(OrderStopLoss()<(FakeProfit-(M2_TakeProfit*pointvalue)))
               {
                if(((Bid - OrderStopLoss()) > (pointvalue * (M2_TrailingStop+TrailingStep))) && (OrderStopLoss() >= OrderOpenPrice() ))
                    ModifyOrder(Bid - pointvalue * M2_TrailingStop,FakeProfit);
               }
            if(Bid>(FakeProfit-(M2_TakeProfit*pointvalue)))
               {
                OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet); 
                return(0);
               }                 
           }
        }   

      if(OrderType() == OP_SELL)
         {
         if(OrderMagicNumber()== MAGICMA_A)
           {
            TradeLog = "FirstTrade";
            if((PhoenixMode==1)&&(M1_TrailingStop>=1))
              {            
               FakeProfit=(OrderOpenPrice()-(2*M1_TakeProfit*pointvalue));  
               if(OrderStopLoss()>(OrderOpenPrice()-(M1_TakeProfit*pointvalue)))
                 {
                  if(((OrderStopLoss() - Ask) > pointvalue * (M1_TrailingStop+TrailingStep)) && (OrderStopLoss() > Ask && OrderStopLoss() <= OrderOpenPrice()))
                     ModifyOrder(Ask + pointvalue * M1_TrailingStop,FakeProfit);
                 }            
               if(OrderStopLoss()>0.01 && Ask<(OrderOpenPrice()-(M1_TakeProfit*pointvalue)))
                 {
                  OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet); 
                  return(0);
                 }
              }                 
            if((PhoenixMode==2)&&(M2_TrailingStop>=1)) 
              {            
               FakeProfit=(OrderOpenPrice()-(2*M2_TakeProfit*pointvalue));  
               if(OrderStopLoss()>(OrderOpenPrice()-(M2_TakeProfit*pointvalue)))
                 {
                  if(((OrderStopLoss() - Ask) > pointvalue * (M2_TrailingStop+TrailingStep)) && (OrderStopLoss() > Ask && OrderStopLoss() <= OrderOpenPrice()))
                     ModifyOrder(Ask + pointvalue * M2_TrailingStop,FakeProfit);
                 }            
               if(OrderStopLoss()>0.01 && Ask<(OrderOpenPrice()-(M2_TakeProfit*pointvalue)))
                 {
                  OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet); 
                  return(0);
                 }
              }                                    
           }
         if((OrderMagicNumber()== MAGICMA_B)&&(M2_TrailingStop>=1)) 
           {
            TradeLog = "Mode2_SecondTrade";  
            if(OrderStopLoss()>(FakeProfit+(M2_TakeProfit*pointvalue)))
               {
                if(((OrderStopLoss() - Ask) > pointvalue * (M2_TrailingStop+TrailingStep)) && (OrderStopLoss() > Ask && OrderStopLoss() <= OrderOpenPrice()))
                    ModifyOrder(Ask + pointvalue * M2_TrailingStop,FakeProfit);
               }            
            if(OrderStopLoss()>0.01 && Ask<(FakeProfit+(M2_TakeProfit*pointvalue)))
               {
                OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet); 
                return(0);
               }                 
           }           
       }
      }
}
//+------------------------------------------------------------------+
//| END Function Check TrailingStop                                  |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| START Function Check BreakEven                                   |
//+------------------------------------------------------------------+

void CheckBreakEven()
{
for(int i=0;i<OrdersTotal();i++)
  {
   if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
   if(OrderSymbol()!=Symbol()) continue;
   if((OrderMagicNumber() != MAGICMA_A)&&(OrderMagicNumber() != MAGICMA_B)) continue;
   
   if(OrderMagicNumber()==MAGICMA_A)
     {
      if((OrderType() == OP_BUY && ((OrderStopLoss()+1*pointvalue) < OrderOpenPrice()))||(OrderType() == OP_SELL && ((OrderStopLoss()-1*pointvalue) > OrderOpenPrice()))||OrderStopLoss()==0)       
          {               
           TradeLog = "FirstTrade";
           if(PhoenixMode==1)
              {
               if ((OrderType()==OP_BUY)&&(Bid-OrderOpenPrice()) > (pointvalue*M1_BreakEven))
                  {
                   FakeProfit=(OrderOpenPrice()+(2*M1_TakeProfit*pointvalue));
                   ModifyOrder((OrderOpenPrice()+pointvalue),FakeProfit);
                  }
               if ((OrderType()==OP_SELL)&&(OrderOpenPrice()-Ask) > (pointvalue*M1_BreakEven))
                  {
                   FakeProfit=(OrderOpenPrice()-(2*M1_TakeProfit*pointvalue));
                   ModifyOrder((OrderOpenPrice()-pointvalue),FakeProfit);
                  }
              }
           if(PhoenixMode==2)
              {
               if (OrderType()==OP_BUY){FakeProfit=(OrderOpenPrice()+(2*M2_TakeProfit*pointvalue));}
               if ((OrderType()==OP_BUY)&&(Bid-OrderOpenPrice()) > (pointvalue*M2_BreakEven))
                    {ModifyOrder((OrderOpenPrice()+pointvalue),FakeProfit);}
               if (OrderType()==OP_SELL){FakeProfit=(OrderOpenPrice()-(2*M2_TakeProfit*pointvalue));}
               if ((OrderType()==OP_SELL)&&(OrderOpenPrice()-Ask) > (pointvalue*M2_BreakEven))
                    {ModifyOrder((OrderOpenPrice()-pointvalue),FakeProfit);}
              }                      
          }                           
     }
   if(OrderMagicNumber()==MAGICMA_B)
     {
      if((OrderType() == OP_BUY && ((OrderStopLoss()+1*pointvalue) < OrderOpenPrice()))||(OrderType() == OP_SELL && ((OrderStopLoss()-1*pointvalue) > OrderOpenPrice()))||OrderStopLoss()==0)       
          {               
           TradeLog = "Mode2_SecondTrade";
           if ((OrderType()==OP_BUY)&&(Bid-OrderOpenPrice()) > (pointvalue*M2_BreakEven))
                {ModifyOrder(OrderOpenPrice(),FakeProfit);}
           if ((OrderType()==OP_SELL)&&(OrderOpenPrice()-Ask) > (pointvalue*M2_BreakEven))
                {ModifyOrder(OrderOpenPrice(),FakeProfit);}
          }                           
     }        
  }
}

//+------------------------------------------------------------------+
//|     END Function Check BreakEven                                 |
//+------------------------------------------------------------------+

//----------------------- PRINT COMMENT FUNCTION
void subPrintDetails()
{
   string sComment   = "";
   string sp         = "----------------------------------------\n";
   string NL         = "\n";
   
   sComment = "Phoenix EA              Copyright  2006, Hendrick" + NL;
   sComment = sComment + NL;
   sComment = sComment + "phoenix ea v01 07 2011     an updated version of  5_6_03" + NL;
   sComment = sComment + "latest update 1 july 2011 made by deVries" + NL;
   sComment = sComment + "http://www.donnaforex.com/forum/index.php?topic=3642.0" + NL;
   sComment = sComment + NL;
   sComment = sComment + NL;
   if(!PrefSettings)
     {
      sComment = sComment + "PrefSettings is false" + NL;
      sComment = sComment + "check PrefSettings if you wanna use the original settings" + NL;
      sComment = sComment + "   PrefSettings has to be value   true" + NL;
     }
   sComment = sComment + "Signal 5   is now GMT timesetting" + NL;
   sComment = sComment + "check GMT time if not true ServerTimezone is wrong" + NL;
   sComment = sComment + NL;
   sComment = sComment + "Server Time:        " + TimeToStr(TimeCurrent(), TIME_SECONDS) + NL;
   sComment = sComment + "GMT Time:          " + TimeToStr((TimeCurrent()+ ((  0 - ServerTimezone) * 3600)), TIME_SECONDS) + NL; 
   sComment = sComment + "ServerTimezone = " + ServerTimezone + "(manual)" + NL;
   Comment(sComment);
}
//+------------------------------------------------------------------+
string errorchek()
{
if(PrefSettings && (Start > 0) && (M1_TakeProfit == 0) && (M1_StopLoss ==0))
   {return("PHOENIX EA: NO working Preffered Setting found");}
return("");
}

      
//+------------------------------------------------------------------+
//| Start Modify Functions to add StopLoss And TakeProfit            |
//+------------------------------------------------------------------+

int Write(string str)
{
//Write log file
   int handle; 
   handle = FileOpen(filename,FILE_READ|FILE_WRITE|FILE_CSV,"/t");
   FileSeek(handle, 0, SEEK_END);      
   FileWrite(handle," Time " + TimeToStr(CurTime(),TIME_DATE|TIME_SECONDS) + ": " + str);
   FileClose(handle);
 Print(str);
}

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int OrdModify(int _ticket, double _price, double _stoploss, double _takeprofit, datetime _expiration, color _color=CLR_NONE) {
//The function modify order with log
double _priceop=0;
int ticket,err,tries;
 
tries = 0;    
  if (!IsTradeContextBusy() && IsTradeAllowed()) {
  while (tries < NumberOfTries) {
   RefreshRates();
   ticket = OrderModify(_ticket,NormalizeDouble(_price,Digits),NormalizeDouble(_stoploss,Digits),NormalizeDouble(_takeprofit,Digits),_expiration,_color);
   if(ticket==0) {
    iError = GetLastError();
// Modified by MrPip for faster backtesting
    if (Log) Write("Error Occured : "+iError + ":" + ErrorDescription(iError));
    if (Log) Write(Symbol()+" Modify @ "+_price+" SL @ "+_stoploss+" TP @"+_takeprofit+" ticket ="+_ticket);
    tries++;
   } else {
    tries = NumberOfTries;
    if (Log) Write("Order modified : "+Symbol()+" Modify @ "+_price+" SL @ "+_stoploss+" TP @"+_takeprofit+" ticket ="+_ticket);
   }
   Sleep(RetryTime*1000);
  }
  }
  err=ticket;
  return(err); 
}
 

//+------------------------------------------------------------------+
//| Modify Order                                                     |
//| Parameters:                                                      |
//|   ldStopLoss   - StopLoss Level                                  |
//|   ldTakeprofit - Takeprofit Level                                |
//+------------------------------------------------------------------+
void ModifyOrder(double ldStopLoss,double ldTakeprofit) {
  bool fm;
  PlaySound("alert.wav");
  fm=OrdModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,ldTakeprofit,0,CLR_NONE);
}

//+------------------------------------------------------------------+
//| NewBar                                                           |
//| Returns true when new bar gets first tick                        |
//| Returns false otherwise                                          |
//| Speed up backtest when there are no open trades                  |
//+------------------------------------------------------------------+
bool NewBar()
{
   static datetime dt = 0;
   
   if (Time[0] != dt)
   {
      dt = Time[0];
      return(true);
   }
   return(false);
}
//+------------------------------------------------------------------+

